#ifndef __CONST_PHILS__
#define __CONST_PHILS__

/* EsounD Constants */

#define ESD_LOCAL_SERVER "localhost:5001"
#define ESD_CONFIG_FILE  "hosts.esd"
#define ESD_GMURF_ID     "Gmurf_client"

/* Gmurf Signature */
#define GMURF_SIGNATURE   "Gmurfrc ;)"
#define NEW_TMPGMURF_NAME "New Wave File"
#define CFG_USELESS_VENDOR_STR 3 // Number of useless characters on the left for OSS

/* Boolean Constants */
#define BOOL  char
#define TRUE_  1
#define FALSE_ 0

/* DspLib Constants */
#define PLAY FALSE_
#define REC  TRUE_

/* Defaults creating mixer sample */
#define DEFAULT_VOLUME 1 // default volume for each sample
#define DEFAULT_DATE 0
#define DEFAULT_PANNING .5
#define DEFAULT_MAX_VOICES 32

/* Maximums coefs  in Gmurf projects */
#define DIV_VOLUME  32
#define DIV_PANNING 256
#define DIV_POINT   256

/* Gmurf Project Parser constants */
#define ID_WAVE      "[WAVE]\n"
#define ID_VOL       "[vol]\n"
#define ID_PAN       "[pan]\n"
#define ID_START     "[start]\n" 
#define ID_DSP       "[dsp]\n"
#define ID_VOLPOINT  "[vol_point]\n"
#define ID_PANPOINT  "[pan_point]\n"
#define ID_FRQPOINT  "[frq_point]\n"
#define ID_REC       "[record]\n"
#define ID_ENDWAVE   "[/WAVE]\n"
#define ID_FRQON     "[frq_on]\n"
#define ID_MUTE      "[mute]\n"
#define ID_END       "[end]\n"

#define MAX_LINE_LEN 200
#define DFT_VOL      3
#define DFT_PAN      .5
#define DFT_START    0

// Gmurf Project Loader constants
#define GMURF_PROJECT_EXTENSION ".GmurfProject"
#define GMURF_PRJ_EXT_LEN strlen(GMURF_PROJECT_EXTENSION)
#define GMURF_WAVE_EXTENSION ".GmurfWave"
#define GMURF_WAVE_EXT_LEN strlen(GMURF_WAVE_EXTENSION)
#define CPY_BUF_SIZE 640000
#define INFORMATION \
";;\n" \
";;\n" \
";; This is a Gmurf Project Header, v0.5\n" \
";;\n" \
";; Syntax:\n" \
";\n" \
"; [WAVE]\n" \
"; wave_file_with_path\n" \
"; [vol]\n" \
"; volume (between 0 and 256)\n" \
"; [pan]\n" \
"; panning (between 0 and 256)\n" \
"; [start]\n" \
"; begin date (in samples)\n" \
"; [dsp]\n" \
"; device number\n" \
";\n" \
"; [frq_on] (optional)\n" \
"; [mute]   (optional)\n" \
";\n"\
"; [/WAVE]\n" \
";\n" \
"; [vol_point] (optional)\n" \
"; x           (in samples)\n" \
"; y           (0-256)\n" \
";\n" \
"; [pan_point] (optional)\n" \
"; x           (in samples)\n" \
"; y           (0-256)\n" \
"; \n" \
"; [frq_point] (optional)\n" \
"; x           (in samples)\n" \
"; y           (1-256)\n" \
"; [record]    (optional)\n" \
"; .\n" \
"; .\n" \
"; .\n" \
";\n" 
#endif /* __CONST_PHILS__ */ 


