/*
** This is an example to show you how to use the MixerKernel.c functions.
** You just have to 'make MixerKernelTest' to compile it.
*/

#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include"MixerTypes.h"
#include"MixerKernel.h"
#include"ConfigLib.h"
#include"DspLib.h"
#include"FileParser.h"

int main(int argc, char **argv[])

{
  t_dsp*        my_dsp;
  t_dsp*        rec_dsp;
  t_dsp*        tmp_dsp;
  t_main_mixer* main_mixer;    /* The main_mixer */
  t_gmurfrc*    my_gmurfrc;    /* Config File */

  int j;

  if (argc <= 1) {
    printf("You must specify a Gmurf Project file\n");
    return(-1);
  }

  /* Initializing the Config Structure with defaults & initializing DSPs */
  my_gmurfrc = gmurfrc_defaults();
  if (my_gmurfrc == NULL)
    {
      printf("No functionnal soundcard was found. ;(\n");
      return(-2);
    }


  /* Constructing the Main Mixer structure. */
  main_mixer = new_main_mixer(my_dsp,2,50,44100,32);

  /* Reading GMURF project */
  if (parse(argv[1],main_mixer,my_dsp) != 0)
    {
      printf("Gmurf project file '%s' not found\n",argv[1]);
      return(-3);
    }
  
  if ((main_mixer->first_mixer_elt != NULL) && 
      (main_mixer->first_mixer_elt->next_mixer_elt != NULL) &&
      (main_mixer->first_mixer_elt->next_mixer_elt->next_mixer_elt != NULL))
    main_mixer->first_mixer_elt->next_mixer_elt->next_mixer_elt->dsp = rec_dsp;
  //main_mixer->first_mixer_elt->next_mixer_elt->dsp = rec_dsp;
  // remove_vol_point(main_mixer->first_mixer_elt, 10000);

  /*
  ** Processing
  */
  
  /* Resetting playing position. */
  main_mixer->played_samples = 0;

  /* Mixer initialization for playing. */
  mixer_initialize(main_mixer);

  /* Processing sound */
  while (mixer_update_buffer(main_mixer) != 0)
    {
      /* Nothing to do. */
    }

  /* Unlocks the DSPs that are used by the mixer. */
  mixer_release(main_mixer);

  /*
  ** Freeing structures from memory
  */

  /* Freeing main mixer. */
  main_mixer_destroy(main_mixer);

  /* Freeing Config Structure & realasing DSPs. */
  gmurfrc_destroy(my_gmurfrc);

  return(0);
}
