/*
** Win_Aux.c for Gmurf in ~/Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Tue Feb 16 19:12:49 1999 Rmi Coupet
** Last update Sun Mar 14 19:12:47 1999 Rmi Coupet
*/


#include "Win_Aux.h"
#include <gtk/gtkwindow.h>
#include "xpms/error.xpm"
#include "xpms/info.xpm"
#include "xpms/stop.xpm"
#include "xpms/warn.xpm"
#include "xpms/yes.xpm"
#include "xpms/no.xpm"
#include "xpms/selected.xpm"
#include "Errors.h"
#include <stdlib.h>
#include "stdio.h"
/*
** Width represent the max number of chars in a line 
*/


typedef	struct	_draw_data draw_data ;
struct		_draw_data
{
  GtkWidget	*win_for_pix ;
  GtkWidget	*old_pix ;
  char		**new_pix ;
} ;

void		change_pix			(GtkWidget	*win_for_pix,
						 GtkWidget	*old_pix,
						 char		**new_pix);

char 		*modify_text_for_dialog		(char	 	*str ,
						 unsigned int	width );

void 		close_app			(void) ;



gushort CountRGB(guint c)
{
  if (c == 0) 
    return 0;
  else {
    c *= 257;
    return (c>0xffff)?0xffff:c;
  }
}


void SetColor(GdkColor *color, guint red, guint green, guint blue)
{
  color->red = CountRGB(red);
  color->green = CountRGB(green);
  color->blue = CountRGB(blue);
}



char 		*modify_text_for_dialog(str, width)
char 		*str ;
unsigned int	width ; /* Max number of chars in a line */
{
  char		*string ;
  int		i ;
  int		start_line ;
  int 		last_stop ;
  size_t	length ;
  
  length = strlen(str) ;
  string = malloc(sizeof(char) * (length + 1)) ;
  strcpy(string, str) ;
  for (i = 0, start_line = 0, last_stop = 0; i < length; i++){
    if ((string[i] == ' ') || (string[i] == '\t')){
      if (i - start_line == width){
	string[i] = '\n' ;
	last_stop = start_line = i ;
      }
      else if (i - start_line > width){
	string[last_stop] = '\n' ;
	start_line = last_stop ;
      }
      else
	last_stop = i ;
    }
    else if (string[i] == '\n')
      last_stop = start_line = i ;
  }
  
  return string ;
}


GtkWidget	*create_new_window_aux(width, 
				       height, 
				       frame_size, 
				       title)
int		width ;
int		height ;
int		frame_size ;
const char	*title ;
{
  GtkWidget *window;

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize(window, (width ? width : AUX_W) , 
		       (height ? height : AUX_H) );
  gtk_window_set_title(GTK_WINDOW (window), title);
  gtk_container_border_width(GTK_CONTAINER (window), 
			     (frame_size ? frame_size : 5));
  gtk_signal_connect_object(GTK_OBJECT (window), "delete_event",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			    GTK_OBJECT (window));
  return window ;
}

 
GtkWidget	*create_principal_window(width, height, frame_size, title)
int		width ;
int		height ;
int		frame_size ;
const char	*title ;
{
  GtkWidget *window;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (window, (width ? width : PRINC_W) , 
			(height ? height : PRINC_H) );
  gtk_window_set_title(GTK_WINDOW (window), title);
  gtk_container_border_width (GTK_CONTAINER (window),
			      (frame_size ? frame_size : 2));  
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (quit), NULL);
  return window ;
}

  
void quit(void)
{
  GtkWidget *Dialog;
  
  Dialog = YesNo_dialog_box(REMI_QUIT,
			     MainWindow, close_app);
  gtk_window_set_modal(GTK_WINDOW (Dialog), TRUE) ;
  gtk_widget_show(Dialog);
}

void close_app()
{
  char		*user ;
  char 		*tmp_dir ;
  PID_T		pid ;
  int		child ;

  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 2) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;
   
  if ((pid = fork()))
  {
    waitpid(pid, &child, WUNTRACED) ;
    if (child != 0)
      printf("child = %d --| Can't delete %s\n", child, tmp_dir) ;
  }
  else
  {
    execlp("/bin/rm", "/bin/rm","-r", "-f", tmp_dir) ;
  }
  
  gtk_main_quit() ;
}

 
GtkWidget	*new_pix_from_data(win_for_pix,
				   pixmap)
GtkWidget	*win_for_pix ;
char		**pixmap ;
{
  GtkWidget	*ret_pix; 
  GdkPixmap	*pix;
  GdkBitmap	*mask;
  GtkStyle	*style;

  style = gtk_widget_get_style( win_for_pix );
  pix = gdk_pixmap_create_from_xpm_d( win_for_pix->window,  &mask,
				      &style->bg[GTK_STATE_NORMAL],
				      pixmap );
  ret_pix = gtk_pixmap_new( pix, mask );
  gtk_widget_show (ret_pix);
  return ret_pix;
}

void		change_pix(win_for_pix,
			   old_pix,
			   new_pix)
GtkWidget	*win_for_pix ;
GtkWidget	*old_pix ;
char		**new_pix ;
{
  GdkPixmap	*pix;
  GdkBitmap	*mask;
  GtkStyle	*style;

  style = gtk_widget_get_style(win_for_pix) ;
  pix = gdk_pixmap_create_from_xpm_d(win_for_pix->window,  &mask,
				     &style->bg[GTK_STATE_NORMAL],
				     new_pix) ;
  gtk_pixmap_set(GTK_PIXMAP (old_pix), pix, mask) ;
  gtk_widget_show(old_pix);
}




GtkWidget	*button2_dialog_box (button1, 
				     button2, 
				     title, 
				     Mess,
				     pixmap, 
				     win_for_pix,
				     func)
char		*button1 ;
char		*button2 ;
char		*title ;
char		*Mess ;
char		**pixmap ;
GtkWidget	*win_for_pix ;
gpointer	func ;
{
  GtkWidget	*window ;
  GtkWidget	*label ;
  GtkWidget 	*button ;
  GtkWidget 	*pix ;
  GtkWidget 	*hbox;
  GtkWidget 	*frame;
  
  window = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW (window), title);
  hbox = gtk_hbox_new(TRUE, 0);
  gtk_widget_set_name(hbox, "dialog box");
  pix = new_pix_from_data (win_for_pix, pixmap);

  gtk_widget_show (pix);
  gtk_box_pack_start(GTK_BOX(hbox), pix, TRUE, TRUE, 0);
  label = gtk_label_new(modify_text_for_dialog(Mess, LINE_WIDTH));
  gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);  
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox),hbox);
  button = Create_Button_with_pixmap_label(button1, yes_xpm, 
					   selected_xpm ,win_for_pix) ;

//  button = gtk_button_new_with_label (button1);
  gtk_widget_set_usize(button, BUTTON_WIDTH, BUTTON_HEIGHT);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (func), NULL);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), 
		      GTK_OBJECT (window));
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(window)->action_area), 
		      button, TRUE, TRUE, 0);
  gtk_widget_show (button);
//  button = gtk_button_new_with_label (button2);
  button = Create_Button_with_pixmap_label(button2, no_xpm, 
					   selected_xpm, win_for_pix) ;
  gtk_widget_set_usize(button, BUTTON_WIDTH, BUTTON_HEIGHT);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), 
		      GTK_OBJECT (window));
  frame = gtk_frame_new(NULL) ;
  gtk_widget_set_usize(frame, BUTTON_WIDTH + 10, BUTTON_HEIGHT + 10) ;
  gtk_container_add(GTK_CONTAINER (frame), button) ;
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(window)->action_area),
		      frame, TRUE, TRUE, 0);
  gtk_widget_show(button);
  gtk_widget_show(frame) ;
  gtk_widget_set_usize(window, DIAL_W, DIAL_H);
  gtk_window_position(GTK_WINDOW (window), GTK_WIN_POS_CENTER) ;
  gtk_widget_show(window);
  return window ;
}

GtkWidget	*YesNo_dialog_box(Mess,
				  win_for_pix, 
				  func)
char		*Mess ;
GtkWidget	*win_for_pix ;
gpointer	func ;
{
  GtkWidget *window;

  window = button2_dialog_box (REMI_YES, REMI_NO, REMI_SHURE, 
			       Mess, stop_xpm, win_for_pix, func);
  gtk_widget_set_name(window, "dialog box");
  return window ;
}


GtkWidget	*Cancel_dialog_box(Mess, 
				   win_for_pix, 
				   func)
char		*Mess ;
GtkWidget	*win_for_pix ;
gpointer	func ;
{
  GtkWidget *window;

  window = button2_dialog_box ("OK", REMI_CANCEL, REMI_MESSAGE, 
			       Mess, warn_xpm, win_for_pix, func);
  gtk_widget_set_name(window, "dialog box");
  return window ;
}



GtkWidget	*button1_dialog_box(title, 
				    Mess, 
				    pixmap, 
				    win_for_pix)
char		*title ;
char		*Mess ;
char		**pixmap ;
GtkWidget	*win_for_pix ;
{
  GtkWidget *window ;
  GtkWidget *label ; 
  GtkWidget *pix ; 
  GtkWidget *button ;
  GtkWidget *hbox ;
  char		*str ;
  
  window = gtk_dialog_new() ;
  gtk_window_set_title(GTK_WINDOW (window), title) ;
  hbox = gtk_hbox_new(FALSE,0) ;
  pix = new_pix_from_data (win_for_pix, pixmap) ;
  gtk_widget_show(pix);
  gtk_box_pack_start(GTK_BOX(hbox), pix, TRUE, TRUE, 0);
  str = modify_text_for_dialog(Mess, LINE_WIDTH) ;
  label = gtk_label_new (str);
  gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);  
  gtk_widget_show (hbox);

  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox),hbox);
  button = Create_Button_with_pixmap_label("OK", yes_xpm, 
					   selected_xpm, win_for_pix);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), 
		      GTK_OBJECT (window));
  gtk_container_add (GTK_CONTAINER(GTK_DIALOG(window)->action_area), 
		      button);
  gtk_widget_show (button);
  gtk_widget_set_usize (window, DIAL_W, DIAL_H);
  gtk_window_position(GTK_WINDOW (window), GTK_WIN_POS_CENTER) ;
  gtk_widget_show(window);
  return window ;
}


GtkWidget	*Info_dialog_box(Mess, 
				 win_for_pix)
char		*Mess ;
GtkWidget	*win_for_pix ;
{
  GtkWidget *window;

  window = button1_dialog_box (REMI_INFO, Mess, info_xpm, win_for_pix);
  gtk_widget_set_name(window, "dialog box");
  return window;
}


GtkWidget	*Error_dialog_box (Mess, 
			     win_for_pix)
char		*Mess ;
GtkWidget	*win_for_pix ;
{
  GtkWidget *window;

  window = button1_dialog_box (REMI_ERROR, Mess, error_xpm, win_for_pix);
  gtk_widget_set_name(window, "dialog box");
  return window;
}


void		light_button(widget,
			     event,
			     data)
GtkWidget	*widget ;
GdkEvent	*event ;
gpointer	data ;
{
  draw_data	*dat ;
  
  dat = (draw_data*) data ;
  change_pix(dat->win_for_pix, dat->old_pix, dat->new_pix);
}


GtkWidget	*Create_Button_with_pixmap_label(ltext, 
						 pixmap, 
						 pixmap_light,
						 win_for_pix) 
char		*ltext ;
gchar		**pixmap ;
gchar		**pixmap_light ;
GtkWidget	*win_for_pix ;
{
  GtkWidget 	*pixmapwid ;
  GtkWidget 	*label ; 
  GtkWidget 	*hbox ;
  GtkWidget 	*button ;
  draw_data	*data ;  
  draw_data	*data2 ;

  data = malloc(sizeof(draw_data));
  data2 = malloc(sizeof(draw_data));
  
  pixmapwid =  new_pix_from_data(win_for_pix, pixmap);
  data->old_pix = pixmapwid ;
  data->new_pix = pixmap_light ;
  data->win_for_pix = win_for_pix ;

  data2->old_pix = pixmapwid ;
  data2->new_pix = pixmap ;
  data2->win_for_pix = win_for_pix ;

  label = gtk_label_new(ltext);
  hbox = gtk_hbox_new(FALSE,0);
  button = gtk_button_new();

  gtk_signal_connect(GTK_OBJECT (button), "enter_notify_event",
		     GTK_SIGNAL_FUNC (light_button), (gpointer) data);
  gtk_signal_connect(GTK_OBJECT (button), "leave_notify_event",
		     GTK_SIGNAL_FUNC (light_button), (gpointer) data2);

  gtk_box_pack_start(GTK_BOX (hbox), pixmapwid, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX (hbox), label, TRUE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(button),hbox);	
  gtk_widget_show(pixmapwid);
  gtk_widget_show(label);
  gtk_widget_show(hbox);
  return button;

}


GtkWidget	*Create_Toggle_Button_with_pixmap_label(ltext, 
						 pixmap, 
						 pixmap_light,
						 win_for_pix) 
char		*ltext ;
gchar		**pixmap ;
gchar		**pixmap_light ;
GtkWidget	*win_for_pix ;
{
  GtkWidget 	*pixmapwid ;
  GtkWidget 	*label ; 
  GtkWidget 	*hbox ;
  GtkWidget 	*button ;
  draw_data	*data ;  
  draw_data	*data2 ;

  data = malloc(sizeof(draw_data));
  data2 = malloc(sizeof(draw_data));
  
  pixmapwid =  new_pix_from_data(win_for_pix, pixmap);
  data->old_pix = pixmapwid ;
  data->new_pix = pixmap_light ;
  data->win_for_pix = win_for_pix ;

  data2->old_pix = pixmapwid ;
  data2->new_pix = pixmap ;
  data2->win_for_pix = win_for_pix ;

  label = gtk_label_new(ltext);
  hbox = gtk_hbox_new(FALSE,0);
  button = gtk_toggle_button_new();

  gtk_signal_connect(GTK_OBJECT (button), "enter_notify_event",
		     GTK_SIGNAL_FUNC (light_button), (gpointer) data);
  gtk_signal_connect(GTK_OBJECT (button), "leave_notify_event",
		     GTK_SIGNAL_FUNC (light_button), (gpointer) data2);

  gtk_box_pack_start(GTK_BOX (hbox), pixmapwid, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX (hbox), label, TRUE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(button),hbox);	
  gtk_widget_show(pixmapwid);
  gtk_widget_show(label);
  gtk_widget_show(hbox);
  return button;

}










